//Редактирование Cinema 13/11/2020
//Переводим станцию на более распространенные датчики - термопары K-Type.

//библиотеки
//#include <AD770X.h>
//AD770X ad7706(2.5);
#include <Wire.h>
#include <string.h>
#include <LiquidCrystal_I2C.h>
//LiquidCrystal_I2C lcd(0x27, 16, 2);
LiquidCrystal_I2C lcd(0x3f, 20, 4);
#include <max6675.h>
#define SENSOR_SAMPLING_TIME 250 //частота обновления текущей температуры (1000=1раз в секунду)
unsigned long nextRead1; //переменная для обновления текущей температуры

//пины подключения
//назначаем пины преобразователей термопар
#define thermoDO  6                             //DO=(SO)
#define thermoCLK  7                            //SCK=(CLK)
#define thermoCS  8                          //CS MAX6675 "ВЕРХНЕГО" нагревателя
#define thermoCS2  9                         //CS MAX6675 "НИЖНЕГО" нагревателя
MAX6675 thermocouple1(thermoCLK, thermoCS, thermoDO);
MAX6675 thermocouple2(thermoCLK, thermoCS2, thermoDO);
#define RelayPin1 12                            //назначаем пин "ВЕРХНЕГО" нагревателя
#define RelayPin2 11                            //назначаем пин "НИЖНЕГО" нагревателя
#define buzzerPin 10                            //назначаем пин пищалки
#define EnableTop 2
#define EnableBottom 3
//#define DRDY 9
//---

//переменные
double R1, R2;
byte LevelTop = 0x00;
byte LevelBottom = 0x00;
double Temp_Top = 0;
double Temp_Bottom = 0;
int Temp1, Temp2, Temp11, Temp12;
byte EnableLed = 0xFF;
char command_in[6];
const byte DESIRED_WIDTH = 3;

void setup() {
  Serial.begin(9600);

  //приветствие
  lcd.begin();
  lcd.clear();
  lcd.backlight();
  lcd.setCursor(1, 0);
  lcd.print("REWORK STATION");
  lcd.setCursor(5, 1);
  lcd.print("v3.0.0");

  SongHello ();//мелодия приветствия
  
  delay(3000);
  lcd.clear();

  //задаём состояние пинов подключения
  pinMode(RelayPin1, OUTPUT);
  pinMode(RelayPin2, OUTPUT);
  pinMode(EnableTop, OUTPUT);
  pinMode(EnableBottom, OUTPUT);
  //задаём состояние пинов, к которым подключены MAX6675
  pinMode(thermoCS, OUTPUT);
  pinMode(thermoCS2, OUTPUT);
  pinMode(thermoCLK, OUTPUT);
  pinMode(thermoDO, INPUT);

  digitalWrite(EnableTop, LOW);
  digitalWrite(EnableBottom, LOW);
  analogWrite(RelayPin1, LevelTop);
  analogWrite(RelayPin2, LevelBottom);
  //ad7706.reset();
  //ad7706.init(AD770X::CHN_AIN1);
  //ad7706.init(AD770X::CHN_AIN2);
  nextRead1 = millis();
}
String addZeroes(const String& src, byte pad)
{
  if (src.length() >= pad)
    return src;
  String result;
  byte add = pad - src.length();
  while (add--)
    result += "0";
  result += src;
  return result;
}

void loop() {

  unsigned long currentMillis = millis();
  if (millis() > nextRead1) {
    nextRead1 = millis() + SENSOR_SAMPLING_TIME;
    R1 = R1 * 0.8 + 0.2 * (thermocouple1.readCelsius());
    R2 = R2 * 0.8 + 0.2 * (thermocouple2.readCelsius());
    double Temp_Bottom = R1;
    double Temp_Top = R2;


    //while ( !digitalRead(DRDY) );
    //R1 = ad7706.readADResult(AD770X::CHN_AIN1);
    //double Temp_Bottom = (R1 - 1) / 0.00392;
    //delay(1);  // раскоментировать, если читает температуру некорректно
    //R2 = ad7706.readADResult(AD770X::CHN_AIN2);
    //double Temp_Top = (R2 - 1) / 0.00392 - 10;

    int i = 0;
    int buffer[6];
    if (Serial.available()) {
      delay(100);
      while ( Serial.available() && i < 7) {
        buffer[i++] = Serial.read();
      }
      buffer[i++] = '\0';
    }
    if (i > 0) {
      if (buffer[0] == 0xAA) {
        LevelTop = buffer[1];
        LevelBottom = buffer[2];
        EnableLed = buffer[3];
      }
      Temp1 = int(Temp_Top);
      Temp11 = 0;
      if (Temp1 > 255) {
        Temp11 = Temp1 - 255;
        Temp1 = 255;
      }
      Temp2 = int(Temp_Bottom);
      Temp12 = 0;
      if (Temp2 > 255) {
        Temp12 = Temp2 - 255;
        Temp2 = 255;
      }
      Serial.write(170);
      Serial.write(Temp1);
      Serial.write(Temp11);
      Serial.write(Temp2);
      Serial.write(Temp12);
      Serial.write(255);
    }
    if (LevelTop == 0x00) {
      digitalWrite(EnableTop, LOW);
    }
    if (LevelTop != 0x00) {
      digitalWrite(EnableTop, HIGH);
    }
    if (LevelBottom == 0x00) {
      digitalWrite(EnableBottom, LOW);
    }
    if (LevelBottom != 0x00) {
      digitalWrite(EnableBottom, HIGH);
    }
    analogWrite(RelayPin1, LevelTop);
    analogWrite(RelayPin2, LevelBottom);
    lcd.setCursor(1, 0);
    lcd.print("TH:");
    lcd.setCursor(1, 1);
    lcd.print("BH:");
    lcd.setCursor(8, 0);
    lcd.print("PWR:");
    lcd.setCursor(8, 1);
    lcd.print("PWR:");
    lcd.setCursor(4, 0);
    lcd.print(addZeroes(String(int(Temp_Top)), DESIRED_WIDTH));
    lcd.setCursor(4, 1);
    lcd.print(addZeroes(String(int(Temp_Bottom)), DESIRED_WIDTH));
    lcd.setCursor(12, 0);
    lcd.print(addZeroes(String(int(LevelTop)), DESIRED_WIDTH));
    lcd.setCursor(12, 1);
    lcd.print(addZeroes(String(int(LevelBottom)), DESIRED_WIDTH));
    if (EnableLed == 0x00) {
      lcd.noBacklight();
    }
    if (EnableLed == 0xFF) {
      lcd.backlight();
    }
  }
}

//---Мелодия приветствия---//
void SongHello () {
  tone(buzzerPin, 523);
  delay(200);
  tone(buzzerPin, 659);
  delay(200);
  tone(buzzerPin, 784);
  delay(200);
  tone(buzzerPin, 1046);
  delay(200);
  noTone(buzzerPin);
}
